diff --git a/test/unit/authorizer_test.rb b/test/unit/authorizer_test.rb
new file mode 100644
index 000000000..24635d7ee
--- /dev/null
+++ b/test/unit/authorizer_test.rb
@@ -0,0 +1,248 @@
+require 'test_helper'
+
+class AuthorizerTest < ActiveSupport::TestCase
+  def setup
+    User.current = User.admin
+
+    @user_role = FactoryGirl.create(:user_user_role)
+    @user      = @user_role.owner
+    @role      = @user_role.role
+  end
+
+  # limited, unlimited, permission with resource, without resource...
+  test "#can?(:view_hosts) with unlimited filter" do
+    permission = Permission.find_by_name('view_hosts')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission])
+    auth       = Authorizer.new(@user)
+
+    assert auth.can?(:view_hosts)
+    refute auth.can?(:view_domains)
+  end
+
+  test "#can?(:view_hosts) with unlimited filter" do
+    permission = Permission.find_by_name('view_hosts')
+    filter     = FactoryGirl.create(:filter, :on_name_all, :role => @role, :permissions => [permission])
+    auth       = Authorizer.new(@user)
+
+    assert auth.can?(:view_hosts)
+    refute auth.can?(:view_domains)
+  end
+
+  test "#can?(:view_hosts) on permission without resource" do
+    permission = Permission.find_by_name('view_hosts')
+    filter     = FactoryGirl.create(:filter, :on_name_all, :role => @role, :permissions => [permission])
+    auth       = Authorizer.new(@user)
+
+    assert auth.can?(:view_hosts)
+    refute auth.can?(:view_domains)
+  end
+
+  test "#can?(:view_hosts) is limited by particular user" do
+    permission = Permission.find_by_name('view_hosts')
+    filter     = FactoryGirl.create(:filter, :on_name_all, :role => @role, :permissions => [permission])
+    auth       = Authorizer.new(FactoryGirl.create(:user))
+
+    refute auth.can?(:view_hosts)
+  end
+
+  test "#can?(:view_domains, @host) for unlimited filter" do
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission])
+    domain     = FactoryGirl.create(:domain)
+    auth       = Authorizer.new(@user)
+
+    assert_include auth.find_collection(Domain, :permission => :view_domains), domain
+    assert auth.can?(:view_domains, domain)
+  end
+
+  test "#can?(:view_domains, @host) for matching limited filter" do
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission],
+                                    :search        => 'name ~ example*')
+    domain     = FactoryGirl.create(:domain)
+    auth       = Authorizer.new(@user)
+
+    assert_include auth.find_collection(Domain, :permission => :view_domains), domain
+    assert auth.can?(:view_domains, domain)
+  end
+
+  test "#can?(:view_domains, @host) for matching and not matching limited filter" do
+    permission = Permission.find_by_name('view_domains')
+    not_matching_filter = FactoryGirl.create(:filter, :role => @role, :permissions => [permission],
+                                             :search        => 'name ~ noexample*')
+    matching_filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission],
+                                             :search        => 'name ~ example*')
+    domain              = FactoryGirl.create(:domain)
+    auth                = Authorizer.new(@user)
+
+    assert_include auth.find_collection(Domain, :permission => :view_domains), domain
+    assert auth.can?(:view_domains, domain)
+  end
+
+  test "#can?(:view_domains, @host) for not matching limited filter" do
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission],
+                                    :search        => 'name ~ noexample*')
+    domain     = FactoryGirl.create(:domain)
+    auth       = Authorizer.new(@user)
+
+    assert_not_include auth.find_collection(Domain, :permission => :view_domains), domain
+    refute auth.can?(:view_domains, domain)
+  end
+
+  test "#can?(:view_domains, @host) filters records by matching limited filter" do
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :on_name_starting_with_a,
+                                    :role => @role, :permissions => [permission])
+    domain1    = FactoryGirl.create(:domain)
+    domain2    = FactoryGirl.create(:domain, :name => 'a-domain.to-be-found.com')
+    auth       = Authorizer.new(@user)
+
+    collection = auth.find_collection(Domain, :permission => :view_domains)
+    assert_not_include collection, domain1
+    assert_include collection, domain2
+    refute auth.can?(:view_domains, domain1)
+    assert auth.can?(:view_domains, domain2)
+  end
+
+  test "#can?(:view_domains, @host) filters records by matching limited filter and permission" do
+    permission1 = Permission.find_by_name('view_domains')
+    permission2 = Permission.find_by_name('edit_domains')
+    filter1     = FactoryGirl.create(:filter, :on_name_starting_with_a,
+                                     :role => @role, :permissions => [permission1])
+    filter2     = FactoryGirl.create(:filter, :on_name_starting_with_b,
+                                     :role => @role, :permissions => [permission2])
+    domain1     = FactoryGirl.create(:domain)
+    domain2     = FactoryGirl.create(:domain, :name => 'a-domain.to-be-found.com')
+    domain3     = FactoryGirl.create(:domain, :name => 'another-domain.to-be-found.com')
+    domain4     = FactoryGirl.create(:domain, :name => 'be_editable.to-be-found.com')
+    auth        = Authorizer.new(@user)
+
+    collection = auth.find_collection(Domain, :permission => :view_domains)
+    assert_equal [domain2, domain3], collection
+    collection = auth.find_collection(Domain, :permission => :edit_domains)
+    assert_equal [domain4], collection
+    collection = auth.find_collection(Domain, :permission => :delete_domains)
+    assert_equal [], collection
+    collection = auth.find_collection(Domain)
+    assert_equal [domain2, domain3, domain4], collection
+
+    refute auth.can?(:view_domains, domain1)
+    assert auth.can?(:view_domains, domain2)
+    assert auth.can?(:view_domains, domain3)
+    refute auth.can?(:view_domains, domain4)
+    refute auth.can?(:edit_domains, domain1)
+    refute auth.can?(:edit_domains, domain2)
+    refute auth.can?(:edit_domains, domain3)
+    assert auth.can?(:edit_domains, domain4)
+
+    # unlimited filter on Domain permission does add the domain
+    filter4 = FactoryGirl.create(:filter, :role => @role, :permissions => [permission1])
+    collection = auth.find_collection(Domain)
+    assert_include collection, domain1
+    assert_include collection, domain2
+    assert_include collection, domain3
+    assert_include collection, domain4
+  end
+
+  test "#can?(:view_domains, @host) for user without filter" do
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission])
+    domain     = FactoryGirl.create(:domain)
+    auth       = Authorizer.new(FactoryGirl.create(:user))
+
+    result = auth.find_collection(Domain, :permission => :view_domains)
+    assert_not_include result, domain
+    assert_kind_of ActiveRecord::Relation, result
+    refute auth.can?(:view_domains, domain)
+  end
+
+  test "#can? caches results per permission and class" do
+    permission1 = Permission.find_by_name('view_domains')
+    filter1     = FactoryGirl.create(:filter, :on_name_starting_with_a,
+                                     :role => @role, :permissions => [permission1])
+    domain1     = FactoryGirl.create(:domain, :name => 'a-domain.to-be-found.com')
+    domain2     = FactoryGirl.create(:domain, :name => 'x-domain.not-to-be-found.com')
+    permission2 = Permission.find_by_name('view_architectures')
+    architecture = FactoryGirl.create(:architecture)
+    filter2      = FactoryGirl.create(:filter, :role => @role, :permissions => [permission2])
+
+    auth        = Authorizer.new(@user)
+
+    auth.stubs(:find_collection).returns([domain1]).times(3)
+    assert auth.can?(:view_domain, domain1)
+    refute auth.can?('view_domain', domain2)
+    assert auth.can?(:edit_domain, domain1)
+    refute auth.can?('edit_domain', domain2)
+    refute auth.can?(:view_architectures, architecture) # since it's stubbed and returns domain1 only
+    refute auth.can?('view_architectures', architecture)
+  end
+
+  test "#build_scoped_search_condition(filters) for empty set" do
+    auth = Authorizer.new(FactoryGirl.create(:user))
+    assert_raises ArgumentError do
+      auth.build_scoped_search_condition([])
+    end
+  end
+
+  test "#build_scoped_search_condition(filters) for one filter" do
+    auth    = Authorizer.new(FactoryGirl.create(:user))
+    filters = [FactoryGirl.build(:filter, :on_name_all)]
+    result  = auth.build_scoped_search_condition(filters)
+
+    assert_equal '(name ~ *)', result
+  end
+
+  test "#build_scoped_search_condition(filters) for more filters" do
+    auth    = Authorizer.new(FactoryGirl.create(:user))
+    filters = [FactoryGirl.build(:filter, :on_name_all), FactoryGirl.build(:filter, :on_name_starting_with_a)]
+    result  = auth.build_scoped_search_condition(filters)
+
+    assert_equal '(name ~ *) OR (name ~ a*)', result
+  end
+
+  test "#build_scoped_search_condition(filters) for unlimited filter" do
+    auth    = Authorizer.new(FactoryGirl.create(:user))
+    filters = [FactoryGirl.build(:filter)]
+    result  = auth.build_scoped_search_condition(filters)
+
+    assert_equal '(1=1)', result
+  end
+
+  test "#build_scoped_search_condition(filters) for limited and unlimited filter" do
+    auth    = Authorizer.new(FactoryGirl.create(:user))
+    filters = [FactoryGirl.build(:filter, :on_name_all), FactoryGirl.build(:filter)]
+    result  = auth.build_scoped_search_condition(filters)
+
+    assert_equal '(name ~ *) OR (1=1)', result
+  end
+
+  test "#build_scoped_search_condition(filters) for empty filter" do
+    auth    = Authorizer.new(FactoryGirl.create(:user))
+    filters = [FactoryGirl.build(:filter, :search => '')]
+    result  = auth.build_scoped_search_condition(filters)
+
+    assert_equal '(1=1)', result
+  end
+
+  test "#can? with empty base collection set" do
+    domain     = FactoryGirl.create(:domain)
+    permission = Permission.find_by_name('view_domains')
+    filter     = FactoryGirl.create(:filter, :role => @role, :permissions => [permission])
+    auth       = Authorizer.new(@user, :collection => [])
+
+    refute auth.can?(:view_domains, domain)
+  end
+
+  test "#can? with excluding base collection set" do
+    permission = Permission.find_by_name('view_domains')
+    filter1    = FactoryGirl.create(:filter, :on_name_starting_with_a,
+                                     :role => @role, :permissions => [permission])
+    domain1    = FactoryGirl.create(:domain, :name => 'a-domain.to-be-found.com')
+    domain2    = FactoryGirl.create(:domain, :name => 'another-domain.to-be-found.com')
+    auth       = Authorizer.new(@user, :collection => [domain2])
+
+    refute auth.can?(:view_domains, domain1)
+    assert auth.can?(:view_domains, domain2)
+  end
+end
diff --git a/test/unit/cached_user_role_test.rb b/test/unit/cached_user_role_test.rb
new file mode 100644
index 000000000..eb7dd466c
--- /dev/null
+++ b/test/unit/cached_user_role_test.rb
@@ -0,0 +1,7 @@
+require 'test_helper'
+
+class CachedUserRoleTest < ActiveSupport::TestCase
+  # test "the truth" do
+  #   assert true
+  # end
+end
diff --git a/test/unit/cached_usergroup_member_test.rb b/test/unit/cached_usergroup_member_test.rb
new file mode 100644
index 000000000..e3004b390
--- /dev/null
+++ b/test/unit/cached_usergroup_member_test.rb
@@ -0,0 +1,7 @@
+require 'test_helper'
+
+class CachedUsergroupMemberTest < ActiveSupport::TestCase
+  # test "the truth" do
+  #   assert true
+  # end
+end
diff --git a/test/unit/common_parameter_test.rb b/test/unit/common_parameter_test.rb
index 402d11bf4..93cd43ed8 100644
--- a/test/unit/common_parameter_test.rb
+++ b/test/unit/common_parameter_test.rb
@@ -43,58 +43,4 @@ class CommonParameterTest < ActiveSupport::TestCase
     assert !parameter2.valid?
     assert  parameter2.errors.full_messages[0] == "Name has already been taken"
   end
-
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_global_variables"
-      role.permissions = ["#{operation}_global_variables".to_sym]
-      @one.roles = [role]
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with create permissions should be able to create" do
-    setup_user "create"
-    record =  CommonParameter.create :name => "dummy", :value => "value"
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  CommonParameter.create :name => "dummy", :value => "value"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  CommonParameter.first
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  CommonParameter.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  CommonParameter.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  CommonParameter.first
-    record.name = "renamed"
-    assert !record.save
-  end
-
 end
diff --git a/test/unit/compute_resource_test.rb b/test/unit/compute_resource_test.rb
index 98deaa647..96f4ff297 100644
--- a/test/unit/compute_resource_test.rb
+++ b/test/unit/compute_resource_test.rb
@@ -5,87 +5,6 @@ class ComputeResourceTest < ActiveSupport::TestCase
     User.current = users(:admin)
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_compute_resources"
-      role.permissions = ["#{operation}_compute_resources".to_sym]
-      @one.roles = [role]
-      @one.compute_resources.destroy_all
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with edit permissions should be able to edit when permitted" do
-    setup_user "edit"
-    as_admin do
-      @one.compute_resources = [compute_resources(:mycompute)]
-    end
-    record = compute_resources(:mycompute)
-    assert record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with edit permissions should not be able to edit when not permitted" do
-    setup_user "edit"
-    record = compute_resources(:yourcompute)
-    assert !record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with edit permissions should not be able to edit when unconstrained" do
-    setup_user "edit"
-    record = compute_resources(:mycompute)
-    assert !record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with destroy permissions should be able to destroy when permitted" do
-    setup_user "destroy"
-    as_admin do
-      @one.compute_resources = [compute_resources(:mycompute)]
-    end
-    record = compute_resources(:mycompute)
-    assert record.destroy
-  end
-
-  test "user with destroy permissions should not be able to destroy when not permitted" do
-    setup_user "destroy"
-    record = compute_resources(:yourcompute)
-    assert !record.destroy
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    as_admin do
-      @one.compute_resources = [compute_resources(:mycompute)]
-    end
-    record = compute_resources(:mycompute)
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    as_admin do
-      @one.compute_resources = [compute_resources(:mycompute)]
-    end
-    record      =  compute_resources(:mycompute)
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    as_admin do
-      @one.compute_resources = [compute_resources(:mycompute)]
-    end
-    record      =  compute_resources(:mycompute)
-    record.name = "renamed"
-    assert !record.save
-  end
-
   test "password is saved encrypted when updated" do
     compute_resource = compute_resources(:one)
     compute_resource.password = "123456"
diff --git a/test/unit/domain_parameter_test.rb b/test/unit/domain_parameter_test.rb
index 36e0a6135..6a8874eaf 100644
--- a/test/unit/domain_parameter_test.rb
+++ b/test/unit/domain_parameter_test.rb
@@ -26,81 +26,11 @@ class DomainParameterTest < ActiveSupport::TestCase
     assert parameter2.valid?
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_domains"
-      role.permissions = ["#{operation}_domains".to_sym]
-      @one.roles = [role]
-      @one.domains.destroy_all
-      @one.save!
+  def setup_user operation, type = 'domains'
+    super(operation, type) do |user|
+      user.domains.destroy_all
     end
-    User.current = @one
   end
 
-  test "user with create permissions should be able to create when permitted" do
-    setup_user "create"
-    as_admin do
-      @one.domains = [domains(:mydomain)]
-    end
-    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with create permissions should not be able to create when not permitted" do
-    setup_user "create"
-    as_admin do
-      @one.domains = [domains(:mydomain)]
-    end
-    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:yourdomain).id
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with create permissions should be able to create when unconstrained" do
-    setup_user "create"
-    as_admin do
-      @one.domains.destroy_all
-    end
-    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
-    assert record.valid?
-    assert !record.new_record?
-  end
-
-  test "user with view permissions should not be able to create" do
-    setup_user "view"
-    record =  DomainParameter.create :name => "dummy", :value => "value", :reference_id => domains(:mydomain).id
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record =  DomainParameter.first
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  DomainParameter.first
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  DomainParameter.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  DomainParameter.first
-    record.name = "renamed"
-    assert !record.save
-  end
 end
 
diff --git a/test/unit/domain_test.rb b/test/unit/domain_test.rb
index 8091f4823..2185d4ad5 100644
--- a/test/unit/domain_test.rb
+++ b/test/unit/domain_test.rb
@@ -72,83 +72,6 @@ class DomainTest < ActiveSupport::TestCase
     hosts(:one)
   end
 
-  def setup_user operation
-    @one = users(:one)
-    as_admin do
-      role = Role.find_or_create_by_name :name => "#{operation}_domains"
-      role.permissions = ["#{operation}_domains".to_sym]
-      @one.roles = [role]
-      @one.domains.destroy_all
-      @one.save!
-    end
-    User.current = @one
-  end
-
-  test "user with edit permissions should be able to edit when permitted" do
-    setup_user "edit"
-    as_admin do
-      @one.domains = [domains(:mydomain)]
-    end
-    record =  Domain.find_by_name "mydomain.net"
-    assert record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with edit permissions should not be able to edit when not permitted" do
-    setup_user "edit"
-    as_admin do
-      @one.domains = [domains(:yourdomain)]
-    end
-    record =  Domain.find_by_name "mydomain.net"
-    assert !record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with edit permissions should be able to edit when unconstrained" do
-    setup_user "edit"
-    record =  Domain.first
-    assert record.update_attributes(:name => "testing")
-    assert record.valid?
-  end
-
-  test "user with view permissions should not be able to create when not permitted" do
-    setup_user "view"
-    record =  Domain.create :name => "dummy", :fullname => "dummy.com"
-    assert record.valid?
-    assert record.new_record?
-  end
-
-  test "user with destroy permissions should be able to destroy" do
-    setup_user "destroy"
-    record = domains(:useless)
-    record.interfaces.clear
-    record.hosts.clear
-    assert record.destroy
-    assert record.frozen?
-  end
-
-  test "user with edit permissions should not be able to destroy" do
-    setup_user "edit"
-    record =  Domain.first
-    record.subnets.clear
-    assert !record.destroy
-    assert !record.frozen?
-  end
-
-  test "user with edit permissions should be able to edit" do
-    setup_user "edit"
-    record      =  Domain.first
-    record.name = "renamed"
-    assert record.save
-  end
-
-  test "user with destroy permissions should not be able to edit" do
-    setup_user "destroy"
-    record      =  Domain.first
-    record.name = "renamed"
-    assert !record.save
-  end
-
   test "should query local nameservers when enabled" do
     Setting['query_local_nameservers'] = true
     assert Domain.first.nameservers.empty?
diff --git a/test/unit/ensure_no_cycle_test.rb b/test/unit/ensure_no_cycle_test.rb
new file mode 100644
index 000000000..c5fe2043f
--- /dev/null
+++ b/test/unit/ensure_no_cycle_test.rb
@@ -0,0 +1,57 @@
+require 'test_helper'
+
+class EnsureNoCycleTest < ActiveSupport::TestCase
+  def setup
+    base = []
+    base.push edge(1, 2)
+    base.push edge(2, 3)
+    base.push edge(3, 4)
+    base.push edge(3, 5)
+    base.push edge(2, 6)
+    @graph = ActiveRecord::Base::EnsureNoCycle.new(base, :source, :target)
+  end
+
+  def edge(source, target)
+    OpenStruct.new(:source => source, :target => target)
+  end
+
+  test "#tsort_each_node iterates over all nodes" do
+    found = []
+    @graph.tsort_each_node { |node| found.push node }
+    assert_equal [1, 2, 3, 4, 5, 6], found
+  end
+
+  test "#tsort_each_child(node) finds all children for node" do
+    found = []
+    assert @graph.tsort_each_child(1) { |node| found.push node }
+    assert_equal [2], found
+
+    found = []
+    assert @graph.tsort_each_child(2) { |node| found.push node }
+    assert_equal [3, 6], found
+
+    found = []
+    assert @graph.tsort_each_child(3) { |node| found.push node }
+    assert_equal [4, 5], found
+
+    found = []
+    assert @graph.tsort_each_child(4) { |node| found.push node }
+    assert_equal [], found
+  end
+
+  test "#ensure detects cycle and raises an exception" do
+    record = edge(6, 1)
+    record.errors = ActiveModel::Errors.new(record)
+    assert_raises Foreman::CyclicGraphException do
+      @graph.ensure(record)
+    end
+    assert_present record.errors[:base], 'cycle did not add error to record'
+  end
+
+  test "#ensure passes when record does not create cycle" do
+    record = edge(2, 4)
+    assert_nothing_raised do
+      assert @graph.ensure(record)
+    end
+  end
+end
diff --git a/test/unit/filter_test.rb b/test/unit/filter_test.rb
new file mode 100644
index 000000000..bfb42f4ad
--- /dev/null
+++ b/test/unit/filter_test.rb
@@ -0,0 +1,157 @@
+require 'test_helper'
+
+class FilterTest < ActiveSupport::TestCase
+  test "#unlimited?" do
+    f = Factory.build :filter
+    assert_nil f.search, 'default filter is not unlimited'
+    assert f.unlimited?
+  end
+
+  test "#limited?" do
+    f = Factory.build :filter, :on_name_all
+    refute_nil f.search, 'filter is not limited'
+    assert f.limited?
+  end
+
+  test "#limited? even for empty string" do
+    f = Factory.build :filter
+    f.search = ''
+    assert f.limited?
+  end
+
+  test ".limited" do
+    f = Factory.create(:filter, :on_name_all)
+    assert_include Filter.limited, f
+  end
+
+  test ".unlimited" do
+    f = Factory.create(:filter)
+    assert_include Filter.unlimited, f
+  end
+
+  test "#resource_type for empty permissions collection" do
+    f = Factory.build(:filter)
+    f.permissions = []
+    assert_nil f.resource_type
+  end
+
+  test "#resource_type" do
+    f = Factory.build(:filter)
+    f.stub :permissions, [ OpenStruct.new(:resource_type => 'test') ] do
+      assert_equal 'test', f.resource_type
+    end
+  end
+
+  test ".get_resource_class known" do
+    assert_equal Bookmark, Filter.get_resource_class('Bookmark')
+  end
+
+  test ".get_resource_class unknown" do
+    assert_nil Filter.get_resource_class('BookmarkThatDoesNotExist')
+  end
+
+  test "#resource_class" do
+    f = Factory.build(:filter, :resource_type => 'Bookmark')
+    Filter.stub :get_resource_class, Architecture do
+      assert_equal Architecture, f.resource_class
+    end
+  end
+
+  test "#granular? for unknown resource type" do
+    f = Factory.build(:filter, :resource_type => 'BookmarkThatDoesNotExist')
+    refute f.granular?
+  end
+
+  test "#granular?" do
+    f = Factory.build(:filter, :resource_type => 'Domain')
+    assert f.granular?
+  end
+
+  test "unlimited filters have nilified search string" do
+    f = Factory.build(:filter, :search => 'name ~ a*', :unlimited => '1')
+    assert f.valid?
+    assert_nil f.search
+
+    f = Factory.build(:filter, :search => '', :unlimited => '1')
+    assert f.valid?
+    assert_nil f.search
+
+    f = Factory.build(:filter, :search => 'name ~ a*', :unlimited => '0')
+    assert f.valid?
+    assert_equal 'name ~ a*', f.search
+  end
+
+  test "filter with organization set is always limited before validation" do
+    o = Factory.create :organization
+    f = Factory.build(:filter, :search => '', :unlimited => '1', :organization_ids => [o.id])
+    assert f.valid?
+    assert f.limited?
+    assert_include f.taxonomy_search, "(organization_id = #{o.id})"
+    assert_not_include f.taxonomy_search, ' and '
+    assert_not_include f.taxonomy_search, ' or '
+  end
+
+  test "filter remains unlimited when no organization assigned" do
+    f = Factory.build(:filter, :search => '', :unlimited => '1', :organization_ids => [])
+    assert f.valid?
+    assert f.unlimited?
+    assert_empty f.taxonomy_search
+  end
+
+  test "filter remains set to unlimited when no taxonomy assigned and has empty search" do
+    f = Factory.build(:filter, :search => '', :unlimited => '0', :organization_ids => [],
+                      :location_ids => [])
+    assert f.valid?
+    assert f.unlimited?
+    assert_empty f.taxonomy_search
+  end
+
+  test "filter with location set is always limited before validation" do
+    l = Factory.create :location
+    f = Factory.build(:filter, :search => '', :unlimited => '1', :location_ids => [l.id])
+    assert f.valid?
+    assert f.limited?
+    assert_include f.taxonomy_search, "(location_id = #{l.id})"
+  end
+
+  test "filter with location set is always limited before validation" do
+    o1 = Factory.create :organization
+    o2 = Factory.create :organization
+    l  = Factory.create :location
+    f  = Factory.build(:filter, :search => '', :unlimited => '1',
+                       :organization_ids => [o1.id, o2.id], :location_ids => [l.id])
+    assert f.valid?
+    assert f.limited?
+    assert_include f.taxonomy_search, "(location_id = #{l.id})"
+    assert_include f.taxonomy_search, "organization_id = #{o1.id}"
+    assert_include f.taxonomy_search, "organization_id = #{o2.id}"
+  end
+
+  test "removing all organizations and locations from filter nilify taxonomy search" do
+    o1 = Factory.create :organization
+    o2 = Factory.create :organization
+    l  = Factory.create :location
+    f  = Factory.create(:filter, :search => '', :unlimited => '1',
+                        :organization_ids => [o1.id, o2.id], :location_ids => [l.id])
+
+    f.update_attributes :organization_ids => [], :location_ids => []
+    assert f.valid?
+    assert f.unlimited?
+    assert_nil f.taxonomy_search
+  end
+
+  test "search string composition" do
+    f = Factory.build :filter, :search => nil, :taxonomy_search => nil
+    assert_equal '', f.search_condition
+
+    f = Factory.build :filter, :search => 'domain ~ test*', :taxonomy_search => nil
+    assert_equal 'domain ~ test*', f.search_condition
+
+    f = Factory.build :filter, :search => nil, :taxonomy_search => 'organization_id = 1'
+    assert_equal 'organization_id = 1', f.search_condition
+
+    f = Factory.build :filter, :search => 'domain ~ test*', :taxonomy_search => 'organization_id = 1'
+    assert_equal '(domain ~ test*) and (organization_id = 1)', f.search_condition
+  end
+
+end
